<?php
/*
   [Discuz!] (C)2001-2011 Comsenz Inc.
   This is NOT a freeware, use is subject to license terms

   $Id: connect_login.php 139 2011-09-22 06:22:18Z liuwenxue $
*/
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

require_once DISCUZ_ROOT.'./include/connect.func.php';

$referer = dreferer();
preg_match('/^(http|https|ftp|javascript):/i', $referer, $matches);
if($matches) {
    $referer = 'index.php';
}

$op = $op ? trim($op, '/') : '';
if(!in_array($op, array('init', 'callback', 'change'))) {
	showmessage('undefined_action');
}

// debug 獲取未授權的request token
if($op == 'init') {

	dsetcookie('con_request_token');
	dsetcookie('con_request_token_secret');

	// debug 請求用戶未授權的tmp token
	$response = connect_get_request_token();
	if(empty($response) || isset($response['error_code'])) {
		showmessage('qqconnect:connect_get_request_token_failed', $referer);
	}

	$request_token = $response['oauth_token'];
	$request_token_secret = $response['oauth_token_secret'];

	// debug 將未授權的oauth_token和oauth_token_secret記到cookie中
	dsetcookie('con_request_token', $request_token);
	dsetcookie('con_request_token_secret', $request_token_secret);

	// debug 返回給Connect應有授權頁面的參數
	$params = array(
		'oauth_token' => $request_token,
		'oauth_consumer_key' => $connectappid,
		'oauth_callback' => $connect_setting['callback_url'],
	);

	dsetcookie('connect_referer', $referer);

	// debug 引導用戶至應用授權頁
	$redirect = $connect_setting['api_url'] . '/oauth/qzoneoauth_authorize?'.connect_http_build_query($params, '', '&');
	dheader('Location:' . $redirect);

// debug Callback處理
} elseif($op == 'callback') {

	$params = $_GET;

	// debug 驗證Connect返回的Sig
	if(!connect_is_valid_openid($params['openid'], $params['timestamp'], $params['oauth_signature'])) {
		showmessage('qqconnect:connect_invalid_params', $referer);
	}

	// debug 在論壇將頁面重定向到connect進行登錄授權前和connect返回到論壇的callback頁後，IE9用了兼容性視圖來接收callback，這導致之前的cookie無法取到了
	// debug 這個操作就是重新載入一下本頁面使之回到正常視圖，目的是解決IE9兼容視圖拿不到cookie
	if(!isset($_GET['receive'])) {
		echo '<script type="text/javascript">setTimeout("window.location.href=\'connect.php?receive=yes&'.str_replace("'", "\'", connect_http_build_query($_GET, '', '&')).'\'", 1)</script>';
		exit;
	}

	// debug 用戶授權後的tmp token
	$request_token = $params['oauth_token'];
	$verify_code = $params['oauth_vericode'];

	if($request_token && $verify_code) {
		$response = connect_get_access_token($request_token, $verify_code);

		if(empty($response) || isset($response['error_code'])) {
			showmessage('qqconnect:connect_get_access_token_failed', $referer);
		}

		$conuin = $response['oauth_token'];
		$conuinsecret = $response['oauth_token_secret'];
		$conopenid = $response['openid'];
		if(!$conuin || !$conuinsecret || !$conopenid) {
			showmessage('qqconnect:connect_get_access_token_failed', $referer);
		}
	} else {
		showmessage('qqconnect:connect_get_request_token_failed', $referer);
	}

	// debug 黑名單
	$query = $db->query("SELECT uin FROM {$tablepre}uin_black");
	while ($result = $db->fetch_array($query)) {
		$connect_blacklist[] = $result['uin'];
	}
	if(in_array($conuin, $connect_blacklist)) {
		$params = array(
			'oauth_token' => $request_token,
			'oauth_consumer_key' => $connectappid,
		);
		$change_qq_url = $connect_setting['change_qq_url'];
		showmessage('qqconnect:connect_uin_in_blacklist', $referer, array('changeqqurl' => $change_qq_url));
	}

	// debug 登陸成功後返回的地址
	$referer = $_DCOOKIE['connect_referer'];
	$referer = $referer && (strpos($referer, 'logging') === false) && (strpos($referer, 'login') === false) ? $referer : 'index.php';

	// debug 種Cookies
	$cookie_expires = 2592000;
	dsetcookie('client_created', time(), $cookie_expires);
	dsetcookie('client_token', $conopenid, $cookie_expires);

	$connect_member = array();
	// debug 獲取新QC綁定用戶綁定關係
	$connect_member = $db->fetch_first("SELECT uid, conuin, conuinsecret, conopenid FROM {$tablepre}member_connect WHERE conopenid='$conopenid'");
	if($connect_member) {
		$member = $db->fetch_first("SELECT uid, conisbind FROM {$tablepre}members WHERE uid='$connect_member[uid]'");
		if($member) {
			if(!$member['conisbind']) {
				unset($connect_member);
			} else {
				$connect_member['conisbind'] = $member['conisbind'];
			}
		} else {
			$db->query("DELETE FROM {$tablepre}member_connect WHERE uid='$connect_member[uid]'");
			unset($connect_member);
		}
	}

	// debug 先用論壇賬號登錄，然後再點擊綁定QQ
	if($discuz_uid) {

		// debug 當前使用的QQ號已經綁有一個論壇賬號，且這個論壇賬號不是當前登錄論壇的賬號
		if($connect_member && $connect_member['uid'] != $discuz_uid) {
			showmessage('qqconnect:connect_register_bind_uin_already', $referer, array('username' => $discuz_user));
		}

		$current_connect_member = $db->fetch_first("SELECT * FROM {$tablepre}member_connect WHERE uid='$discuz_uid'");
		if($current_connect_member) {
			// debug 當前論壇登錄者已經綁了另一個QQ號了，無法再綁定當前這個QQ號
			if($current_connect_member['conopenid'] && $current_connect_member['conopenid'] != $conopenid) {
				showmessage('qqconnect:connect_register_bind_already', $referer);
			}

			$db->query("UPDATE {$tablepre}member_connect SET conuin='$conuin', conuinsecret='$conuinsecret', conopenid='$conopenid', conisregister='0' WHERE uid='$discuz_uid'");

		} else { // debug 當前登錄的論壇賬號並沒有綁定任何QQ號，則可以綁定當前的這個QQ號
			$db->query("INSERT INTO {$tablepre}member_connect (uid, conuin, conuinsecret, conopenid, conisregister) VALUES ('$discuz_uid', '$conuin', '$conuinsecret', '$conopenid', '0')");
		}

		$db->query("UPDATE {$tablepre}members SET conisbind='1' WHERE uid='$discuz_uid'");

		// debug 用戶綁定通知Connect
		dsetcookie('connect_js_name', 'user_bind', 86400);
		dsetcookie('connect_js_params', base64_encode(serialize(array('type' => 'loginbind'))), 86400);
		dsetcookie('connect_login', 1, 31536000);
		dsetcookie('connect_is_bind', '1', 31536000);
		dsetcookie('connect_uin', $conopenid, 31536000);
		dsetcookie('stats_qc_reg', 3, 86400, 0, false);
		$inshowmessage = 1;

		// debug 記錄QC用戶綁定
		$timestamp = time();
		$db->query("INSERT INTO {$tablepre}connect_memberbindlog (uid, uin, type, dateline) VALUES ('$discuz_udi', '$conopenid', '1', '$timestamp')");

		showmessage('qqconnect:connect_register_bind_success', $referer);

	// debug 未登錄用戶
	} else {

		if($connect_member) { // debug 此分支是用戶直接點擊QQ登錄，並且這個QQ號已經綁好一個論壇賬號了，將直接登進論壇了

			$db->query("UPDATE {$tablepre}member_connect SET conuin='$conuin', conuinsecret='$conuinsecret' WHERE uid='$connect_member[uid]'");

			$params['mod'] = 'login';
			connect_login($connect_member);

			include_once DISCUZ_ROOT . './forumdata/cache/cache_usergroups.php';
			$usergroups = $_DCACHE['usergroups'][$groupid]['grouptitle'];
			dsetcookie('stats_qc_login', 3, 86400, 0, false);
			showmessage('login_succeed', $referer);

		} else { // debug 此分支是用戶直接點擊QQ登錄，並且這個QQ號還未綁定任何論壇賬號，將將跳轉到一個新頁引導用戶註冊個新論壇賬號或綁一個已有的論壇賬號

			// debug 為避免二次請求access token
			// debug 將access token加密後，傳給註冊程序
			$encode[] = authcode($conuin, 'ENCODE');
			$encode[] = authcode($conuinsecret, 'ENCODE');
			$encode[] = authcode($conopenid, 'ENCODE');
			$auth_hash = authcode(implode('|', $encode), 'ENCODE');
			// debug 加密串種Cookie
			dsetcookie('con_auth_hash', $auth_hash);

			unset($params['op']);
			$params['mod'] = 'register';
			$params['referer'] = $referer;

			unset($params['oauth_token']);
			unset($params['oauth_verifycode']);

			$redirect = 'connect.php?'.connect_http_build_query($params, '', '&');
			header("Location: $redirect");
			exit;
		}
	}

// debug 更換QQ賬號重登錄
} elseif($op == 'change') {

	dsetcookie('con_request_token');
	dsetcookie('con_request_token_secret');

	// debug 請求用戶未授權的tmp token
	$response = connect_get_request_token();
	if(empty($response) || isset($response['error_code'])) {
		showmessage('qqconnect:connect_get_request_token_failed', $referer);
	}

	$request_token = $response['oauth_token'];
	$request_token_secret = $response['oauth_token_secret'];

	dsetcookie('con_request_token', $request_token);
	dsetcookie('con_request_token_secret', $request_token_secret);

	$params = array(
		'oauth_token' => $request_token,
		'oauth_consumer_key' => $connectappid,
		'oauth_callback' => $connect_setting['callback_url'],
	);

	$redirect = $connect_setting['api_url'] . '/oauth/qzoneoauth_authorize?'.connect_http_build_query($params, '', '&');
	header('Location:' . $redirect);
	exit;
}

function connect_login($connect_member) {

	global $db, $tablepre, $_DCACHE, $_DCOOKIE;

	$member = $db->fetch_first("SELECT m.uid AS discuz_uid, m.username AS discuz_user, m.password AS discuz_pw,
							   m.secques AS discuz_secques,
							   m.email, m.adminid, m.groupid, m.styleid, m.lastvisit, m.lastpost,
							   m.conisbind,
							   u.allowinvisible
							   FROM {$tablepre}members m LEFT JOIN {$tablepre}usergroups u USING (groupid)
							   WHERE m.uid='$connect_member[uid]'");
	if (!$member) {
		return false;
	}

	$member['discuz_userss'] = $member['discuz_user'];
	$member['discuz_user'] = addslashes($member['discuz_user']);
	foreach ($member as $var => $value) {
		$GLOBALS[$var] = $value;
	}

	$GLOBALS['styleid'] = $member['styleid'] ? $member['styleid'] : $_DCACHE['settings']['styleid'];

	$cookietime = 1296000;
	dsetcookie('connect_login', 1, $cookietime);
	dsetcookie('connect_is_bind', '1', 31536000);
	dsetcookie('connect_uin', $connect_member['conopenid'], 31536000);

	dsetcookie('cookietime', $cookietime, 31536000);
	dsetcookie('auth', authcode("$member[discuz_pw]\t$member[discuz_secques]\t$member[discuz_uid]", 'ENCODE'), $cookietime, 1, true);
	dsetcookie('loginuser');
	dsetcookie('activationauth');
	dsetcookie('pmnum');

	$GLOBALS['sessionexists'] = 0;

	return true;
}
?>
