<?php

/*
	[DUCEDIS] (C)2007-2008 Ducedis.com
    This is a freeware, use is subject to license terms
    Script filenameducecp.func.php

    Support: www.ducedis.com

*/

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

function duce_matchsettings($settings, &$settingsnew, $utt = 1){
	foreach((array)$settings as $key => $value){
		if(!$utt && !isset($settingsnew[$key])){
			continue;
		}
		if(is_array($value)){
			duce_matchsettings($value, $settingsnew[$key]);
		}else if(is_string($value)){
			$settingsnew[$key] = isset($settingsnew[$key]) ? stripcslashes(trim($settingsnew[$key])) : $value;
		}else{
			$settingsnew[$key] = isset($settingsnew[$key]) ? intval($settingsnew[$key]) : $value;
		}
	}
}

function duce_mergelang($ducepath, $name = 'admin', $tpldir = 'template'){
	global $duce_charset;
	$ducelang = array();
	@include $ducepath.$tpldir.'/'.$name.$duce_charset.'.lang.php';	
	$GLOBALS['lang'] = @array_merge($GLOBALS['lang'], $ducelang);
}

function duce_charset($name = ''){
	global $scriptlang, $plugin, $charset;

	if(substr(strtoupper($charset), 0, 2) == 'GB'){
		return $name;
	}elseif(strtoupper($charset) == 'BIG5'){
		return $name.'_tc_big5';
	}elseif(substr(strtoupper($charset), 0, 3) == 'UTF'){
		$char = $GLOBALS['installtype'] ? $GLOBALS['installtype'] : $scriptlang[$plugin['identifier']]['charset'];
		if(strtoupper($char) == 'TC_UTF8'){
			return $name.'_tc_utf8';
		}
		return $name.'_sc_utf8';
	}
	return $name;
}

function duce_convnum($n, $u = '*', $m = 1000){
	if($n = intval($n)){
		eval("\$n = floor($n$u$m);");
	}
	return $n;
}

if(!function_exists('file_get_contents')) {
	function file_get_contents($filename) {
		$fp = @fopen($filename, 'r');
		$data = @fread($fp, filesize($filename));
		@fclose($fp);
		return $data;
	}
}

if(!function_exists('file_put_contents')) {
	function file_put_contents($filename, $s) {
		$fp = @fopen($filename, 'w');
		@fwrite($fp, $s);
		@fclose($fp);
		return TRUE;
	}
}

if(!function_exists('dir_writeable')) {
	function dir_writeable($dir) {
		if(!is_dir($dir)) {
			@mkdir($dir, 0777);
		}
		if(is_dir($dir)) {
			if($fp = @fopen("$dir/test.txt", 'w')) {
				@fclose($fp);
				@unlink("$dir/test.txt");
				$writeable = 1;
			} else {
				$writeable = 0;
			}
		}
		return $writeable;
	}
}

if(!function_exists('lang')) {
	function lang($name, $force = true) {
		global $lang;
		return isset($lang[$name]) ? $lang[$name] : ($force ? $name : '');
	}
}

function duce_createdir($dirpath){
	$paths = explode('/', substr(str_replace('\\', '/', $dirpath), strlen(DISCUZ_ROOT)));
	$return = true;
	$truepath = $coma = '';
	foreach($paths as $i => $path){
		$path = trim($path);
		if($path == '' || strpos($path, '.') !== false) continue;
		$truepath .= $coma.$path;
		$coma = '/';
		if(!($return = dir_writeable(DISCUZ_ROOT.'./'.$truepath))) break;
	}
	return $return;
}

if(!function_exists('isfounder')) {
	function isfounder($user = '') {
		$user = empty($user) ? array('uid' => $GLOBALS['discuz_uid'], 'adminid' => $GLOBALS['adminid'], 'username' => $GLOBALS['discuz_userss']) : $user;
		$founders = str_replace(' ', '', $GLOBALS['forumfounders']);
		if($user['adminid'] <> 1) {
			return FALSE;
		} elseif(empty($founders)) {
			return TRUE;
		} elseif(strexists(",$founders,", ",$user[uid],")) {
			return TRUE;
		} elseif(!is_numeric($user['username']) && strexists(",$founders,", ",$user[username],")) {
			return TRUE;
		} else {
			return FALSE;
		}
	}
}

function duce_writejscache($partjsdir = ''){
	if($partjsdir == ''){
		return;
	}
	$dir = DISCUZ_ROOT.'plugins/'.$partjsdir.'js/';
	$cachedir = DISCUZ_ROOT.'plugins/'.$partjsdir.'cache/';
	$dh = opendir($dir);
	$remove = array(
		'/(^|\r|\n)\/\*.+?(\r|\n)\*\/(\r|\n)/is',
		'/\/\/.+?(\r|\n)/i',
		'/\/\/note.+?(\r|\n)/i',
		'/\/\/debug.+?(\r|\n)/i',
		'/(^|\r|\n)(\s|\t)+/',
		'/(\r|\n)/',
	);
	while(($entry = readdir($dh)) !== false) {
		if(fileext($entry) == 'js') {
			$jsfile = $dir.$entry;
			$fp = fopen($jsfile, 'r');
			$jsdata = @fread($fp, filesize($jsfile));
			fclose($fp);
			$jsdata = preg_replace($remove, '', $jsdata);
			if(@$fp = fopen($cachedir.$entry, 'w')) {
				fwrite($fp, $jsdata);
				fclose($fp);
			} else {
				exit('
				Can not write to cache files, please check directory: 
					./plugins/ and 
					./plugins/'.$partjsdir.' 
					./plugins/'.$partjsdir.'cache/
				');
			}
		}
	}
}

function ducecompare($x, $y){
	if($x == $y) return 0;
	else if($x < $y) return -1;
	else return 1;
}

function ducearrull($v){
	if(trim($v)!=="") return true; 
	else return false;
}

function duce_formheader($action, $extra = '', $name = 'duceform'){
	showformheader($action, $extra, $name);
	showhiddenfields(array('duceanchor' => htmlspecialchars($GLOBALS['duceanchor'])));
}

function duce_subtitle($menus, $anchor = 'duceanchor'){
	global $ducescript;
	if(is_array($menus)) {
		showtableheader('', 'ducetb');
		$s = '<div class="ducetitle"><ul id="ducesubtitle" class="tab1">';
		foreach($menus as $k => $menu){
			if(is_array($menu[0])){
				$s .= '<li id="addjs'.$k.'" class="'.($menu[2] ? ' current' : 'hasdropmenu').'" onclick="dropmenu(this);"><a href="#"><span>'.lang($menu[0]['menu']).'<em>&nbsp;&nbsp;</em></span></a><div id="addjs'.$k.'child" class="dropmenu" style="display:none;">';
				if(is_array($menu[0]['submenu'])) {
					foreach($menu[0]['submenu'] as $submenu) {
						$s .= '<a href="'.$ducescript.'&ducejob='.$submenu[1].'">'.lang($submenu[0]).'</a>';
					}
				}
				$s .= '</div></li>';
			}else{
				$s .= '<li'.($menu[2] ? ' class="current"' : '').' id="duce_'.$menu[1].'" '.($menu[3] ? '' : 'onclick="duceshowanchor(this)"').'><a'.($menu[3] ? ' href="'.$ducescript.'&'.$anchor.'='.$menu[1].'"' : '').'><span>'.lang($menu[0]).'</span></a></li>';
			}
		}
		$s .= '</ul></div>';
		echo "\n".'<tr><th style="height:5px; padding:5px 0 0;"></th></tr>';
		showtitle($s);
		showtablefooter();
	}
}

function duce_anchorheader($id, $tbclassname = '', $extra = ''){
	showtagheader('div', 'ducedis_'.$id, $GLOBALS['duceanchor'] == $id, 'duceanchor');
	showtableheader('', $tbclassname, $extra);
}

function duce_anchortips($tips, $id = 'tips', $display = TRUE){
	if(lang($tips, false)) {
		eval('$tips = "'.str_replace('"', '\\"', lang($tips)).'";');
	}
	showtableheader('', 'dtips', 'id="'.$id.'"'.(!$display ? ' style="display: none;"' : ''), 0);
	showtablerow('', 'class="tipsblock"', '<ul id="'.$id.'lis">'.$tips.'</ul>');
	showtablefooter();
}

function duce_anchorfooter(){
	showtablefooter();
	showtagfooter('div');
}

function duce_hankwork($hooksfiles = array()){
	if(!is_array($hooksfiles)) return '';
	$i = 1;
	$handworks = '<ol>';
	foreach($hooksfiles as $file => $hooks){
		if(is_array($hooks)){
			$handworks .= '<li>'.lang('inhooks_'.fileext($file)).'&nbsp;"<cite>'.$file.'</cite>&nbsp;" :';
			if(is_array($hooks[0])){
				foreach($hooks as $key => $val){
					if($val[4]){
						$handworks .= '<br><strong>'.lang($val[4]).'</strong>';
					}
					$handworks .= '<br>'.lang('inhooks_search'.($key && !$val[4] ? '1' : '')).': <span>'.htmlspecialchars($val[0]).'</span>';
					$handworks .= '<br>'.lang('inhooks_'.$val[2]).': <br><em id="code_'.$i.'">'.htmlspecialchars($val[1]).'</em><br>';
					$handworks .= '<p><em onclick="copycode($(\'code_'.$i.'\'));">'.lang('inhooks_copycode').'</em></p></li>';
					$i++;
				}
			}else{
				$handworks .= '<br>'.lang('inhooks_search').': <span>'.htmlspecialchars($hooks[0]).'</span>';
				$handworks .= '<br>'.lang('inhooks_'.$hooks[2]).' : <br><em id="code_'.$i.'">'.htmlspecialchars($hooks[1]).'</em><br>';
				$handworks .= '<p><em onclick="copycode($(\'code_'.$i.'\'));" class="copycode">'.lang('inhooks_copycode').'</em></p></li>';
				$i++;
			}
		}else{
			$handworks .= '<li>'.$hooks.'</li>';
		}
	}
	$handworks .= '</ol>';
	showtablerow('', 'class="inhooks"', $handworks);
}

function duce_header($cssappend = 'ducedis', $cssdir = 'images'){
	global $plugin;
	$cssfile = $plugin['directory'].$cssdir.'/'.$cssappend.'.css';
	cpheader();
	echo $cssappend ? '<link href="./plugins/'.$cssfile.'?'.VERHASH.'" rel="stylesheet" type="text/css" />'."\n" : '';
?>
<script language="JavaScript">
<!--
function duceaddrow(obj, type) {
	var rc = 0;
	var table = obj.parentNode.parentNode;
	var tr = obj.parentNode;
	for (var a=0; a<8; a++){
		if(table.tagName.toLowerCase() != 'table'){
			table = table.parentNode; rc++;
		}
		if(tr.tagName.toLowerCase() != 'tr'){
			tr = tr.parentNode;	rc++;
		}
	}

	if(rc<2){addrowdirect = 0;	return false;}

	var row = addrowdirect ? table.insertRow(tr.rowIndex + 1) : table.insertRow(tr.rowIndex);

	var typedata = rowtypedata[type];
	for(var i = 0; i <= typedata.length - 1; i++) {
		var cell = row.insertCell(i);
		cell.colSpan = typedata[i][0];
		var tmp = typedata[i][1];
		if(typedata[i][2]) {
			cell.className = typedata[i][2];
		}
		tmp = tmp.replace(/\{(\d+)\}/g, function($1, $2) {return duceaddrow.arguments[parseInt($2) + 1];});
		cell.innerHTML = tmp;
	}
	addrowdirect = 0;
}
function copycode(obj) {
	setcopy(is_ie ? obj.innerText.replace(/\r\n\r\n/g, '\r\n') : obj.textContent, '<?=lang('inhooks_copycode_r')?>');
}
function duceshowanchor(obj){
	var childs = $('ducesubtitle').getElementsByTagName('li');
	for (var i = 0; i < childs.length; i++)	{
		if (childs[i].className == 'current') {
			$('ducedis_' + childs[i].id.substr(5)).style.display = 'none';
			childs[i].className = '';
			if($(childs[i].id.substr(5) + '_tips')) $(childs[i].id.substr(5) + '_tips').style.display = 'none';
			break;
		}
	}
	if($(obj.id.substr(5) + '_tips')) $(obj.id.substr(5) + '_tips').style.display = '';
	if($(obj.id.substr(5) + 'form')) {
		$(obj.id.substr(5) + 'form').duceanchor.value = obj.id.substr(5);
	}else if($('duceform')) {
		$('duceform').duceanchor.value = obj.id.substr(5);
	}
	obj.className = "current";
	$('ducedis_' + obj.id.substr(5)).style.display = 'block';
}
//-->
</script>
<?
}

function duce_footer(){
	global $plugin;
	echo <<<EOT
<div class="itemtitle ducefooter">
Powered by <a href="http://www.ducedis.com" target=_blank><em>$plugin[name]</em></a> <cite>$plugin[version]</cite>&nbsp;&copy; 2007-2009, 
<a href="http://www.ducedis.com" target="_blank">www.ducedis.com</a></div>&nbsp;<br>&nbsp;
</div>
</body>
</html>
EOT;
	updatesession();
	exit;
}

function duce_cpmsg($message, $url = '', $type = '', $extra = '', $stop = TRUE) {
	extract($GLOBALS, EXTR_SKIP);
	eval("\$message = \"".(isset($lang[$message]) ? $lang[$message] : $message)."\";");
	if($inajax){
		ajaxshowheader();
		echo '<script type="text/JavaScript">alert("'.addcslashes(strip_tags($message), '"').'");</script>';
		ajaxshowfooter();
		exit();
	}
	switch($type) {
		case 'succeed': $classname = 'infotitle2';break;
		case 'error': $classname = 'infotitle3';break;
		case 'loading': $classname = 'infotitle1';break;
		default: $classname = 'marginbot normal';break;

	}
	$message = "<h4 class=\"$classname\">$message</h4>";

	if($type == 'form') {
		$message = "<form method=\"post\" action=\"$url\"><input type=\"hidden\" name=\"formhash\" value=\"".FORMHASH."\">".
			"<br />$message$extra<br />".
			"<p class=\"margintop\"><input type=\"submit\" class=\"btn\" name=\"confirmed\" value=\"$lang[ok]\"> &nbsp; \n".
			"<input type=\"button\" class=\"btn\" value=\"$lang[cancel]\" onClick=\"history.go(-1);\"></p></form><br />";
	} elseif($type == 'loadingform') {
		$message = "<form method=\"post\" action=\"$url\" id=\"loadingform\"><input type=\"hidden\" name=\"formhash\" value=\"".FORMHASH."\"><br />$message$extra<img src=\"images/admincp/ajax_loader.gif\" class=\"marginbot\" /><br />".
			'<p class="marginbot"><a href="###" onclick="$(\'loadingform\').submit();" class="lightlink">'.lang('message_redirect').'</a></p></form><br /><script type="text/JavaScript">setTimeout("$(\'loadingform\').submit();", 2000);</script>';
	} else {
		$message .= $extra.($type == 'loading' ? '<img src="images/admincp/ajax_loader.gif" class="marginbot" />' : '');
		if($url) {
			if($type == 'button') {
				$message = "<br />$message<br /><p class=\"margintop\"><input type=\"submit\" class=\"btn\" name=\"submit\" value=\"$lang[start]\" onclick=\"location.href='$url'\" />";
			} else {
				$message .= '<p class="marginbot"><a href="'.$url.'" class="lightlink">'.lang('message_redirect').'</a></p>';
				$url = transsid($url);
				$message .= "<script type=\"text/JavaScript\">setTimeout(\"redirect('$url');\", 2000);</script>";
			}
		} elseif(strpos($message, $lang['return'])) {
			$message .= '<p class="marginbot"><a href="javascript:history.go(-1);" class="lightlink">'.lang('message_return').'</a></p>';
		}
	}

	if($stop) {
		//echo '<h3>'.lang('ducedis_message').'</h3><div class="infobox">'.$message.'</div>';
		echo '<div class="infobox">'.$message.'</div>';
		duce_footer();
		dexit();
	} else {
		echo '<div class="infobox">'.$message.'</div>';
	}
}

function forumselect($forumselected = array()) {
	global $_DCACHE, $discuz_uid, $groupid, $fid;

	if(!isset($_DCACHE['forums'])) {
		require_once DISCUZ_ROOT.'./forumdata/cache/cache_forums.php';
	}

	$forumlist = '<optgroup label="&nbsp;">';
	foreach($_DCACHE['forums'] as $forum) {
		$selected = is_array($forumselected) && in_array($forum['fid'], $forumselected) ? ' selected' : '';
		if($forum['type'] == 'group') {
			$forumlist .= '</optgroup><optgroup label="'.$forum['name'].'">';
			$visible[$forum['fid']] = true;
		} elseif($forum['type'] == 'forum' && isset($visible[$forum['fup']])) {
			$forumlist .= '<option value="'.$forum['fid'].'"'.$selected.'>&nbsp; &gt; '.$forum['name'].'</option>';
			$visible[$forum['fid']] = true;
		} elseif($forum['type'] == 'sub' && isset($visible[$forum['fup']])) {
			$forumlist .= '<option value="'.$forum['fid'].'"'.$selected.'>&nbsp; &nbsp; &nbsp; &gt; '.$forum['name'].'</option>';
		}
	}
	$forumlist .= '</optgroup>';
	$forumlist = str_replace('<optgroup label="&nbsp;"></optgroup>', '', $forumlist);

	return $forumlist;
}

function duce_charconvert($str, $source = 'GBK', $target = 'HTML-ENTITIES'){
	return @mb_convert_encoding($str, $target, $source);
}

?>