<?php
/*
	Moderator Precinct Display
	Plugin FOR Discuz! New Core
	Copyright (c) 2007 - 2009 IF-Studio.
	$Id: ifs_precinct.class.php 88 2009-07-16 02:08:00Z Simon $
*/

!defined('IN_DISCUZ') && exit('Access Denied');

class plugin_ifs_precinct {
	var $precinct = array();
	var $forums = array();
	var $authors = array();
	
	function plugin_ifs_precinct() {
		include template('precinct', 'ifs', './plugins/ifs_precinct/templates');
		global $_DCACHE, $discuz_uid;
		if(!@include DISCUZ_ROOT.'./forumdata/cache/cache_ifs_precinct.php') {
			$_IFSCACHE['precinct'] = $this->_ifs_updateCache();
		}
		$this->precinct = $_IFSCACHE['precinct'];
		if(is_array($_DCACHE['forums'])) {
			foreach($_DCACHE['forums'] as $key => $val) {
				if(!$val['viewperm'] || ($val['viewperm'] && forumperm($val['viewperm'])) || strstr($val['users'], "\t$discuz_uid\t")) {
					$val['url'] = $val['type'] == 'group' ? "index.php?gid=$val[fid]" : "forumdisplay.php?fid=$val[fid]";
					$this->forums[$key] = $val;
				}
			}
		}
	}
	
	function _ifs_updateCache() {
		global $db, $tablepre;
		$return = array();
		$query = $db->query("SELECT m.fid, m.uid FROM {$tablepre}moderators m, {$tablepre}forums f WHERE m.inherited='0' AND f.status>0 AND m.fid=f.fid ORDER BY f.type, f.displayorder");
		while($mod = $db->fetch_array($query)) {
			$return[$mod['uid']][] = $mod['fid'];
		}
		include_once DISCUZ_ROOT.'./include/cache.func.php';
		writetocache('ifs_precinct', '', getcachevars(array('_IFSCACHE' => array('precinct' => $return))));
		return $return;
	}
	
	function viewthread_top_output() {
		return tpl_ifs_precinctcss();
	}
	
	function viewthread_sidetop_output() {
		global $postlist;
		$return = array();
		if($_GET['viewpid']) {
			$return[] = '';
		}
		include_once DISCUZ_ROOT.'./forumdata/cache/plugin_ifs_precinct.php';
		if(is_array($postlist) && $this->forums) {
			$viewfids = array_keys($this->forums);
			foreach($postlist as $key => $val) {
				if($val['author'] && isset($this->precinct[$val['authorid']])) {
					$temp = array_intersect($viewfids, $this->precinct[$val['authorid']]);
					if($temp) {
						$return[] = tpl_ifs_precinct($temp, $this->forums, $_DPLUGIN['ifs_precinct']['vars'], $key);
					} else {
						$return[] = '';
					}
				} else {
					$return[] = '';
				}
			}
		}
		return $return;
	}

}

?>